package com.huiju.estateagents.third.controller;

import com.huiju.estateagents.base.ResponseBean;
import com.huiju.estateagents.common.WxMpUtils;
import lombok.AllArgsConstructor;
import me.chanjar.weixin.common.error.WxErrorException;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.bean.result.WxMpOAuth2AccessToken;
import me.chanjar.weixin.mp.bean.result.WxMpUser;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;

/**
 * @author Edward
 */
@AllArgsConstructor
@Controller
@RequestMapping("/api")
public class WxRedpackController {
    public WxMpUtils wxMpUtils;

    /**
     * 换取openid接口并插入公众号人员表
     * @param appid
     * @param code
     * @param request
     * @return
     */
    @GetMapping("/third/redirect/{appid}/greet")
    public ResponseBean greetUser(@PathVariable String appid, @RequestParam String code, HttpServletRequest request) {
        WxMpService wxService = wxMpUtils.wxMpService();
        if (!wxService.switchover(appid)) {
            throw new IllegalArgumentException(String.format("未找到对应appid=[%s]的配置，请核实！", appid));
        }
        String openId = null;
        try {
            //换取openid
            WxMpOAuth2AccessToken accessToken = wxService.oauth2getAccessToken(code);
            WxMpUser user = wxService.oauth2getUserInfo(accessToken, null);
            openId = user.getOpenId();
            //插入公众号人员信息并插入表

        } catch (WxErrorException e) {
            e.printStackTrace();
        }

        return ResponseBean.success(openId);
    }
}
